'#Reference {00020813-0000-0000-C000-000000000046}#1.9#0#C:\Program Files (x86)\Microsoft Office\Root\Office16\EXCEL.EXE#Microsoft Excel 16.0 Object Library#Excel
Sub Main
    Call Example1
    Call Example2
    Call Example3
End Sub

'SUMMARY
'Method shows how To export data To pdfPost without Any additional configuration data
Sub Example1
	Dim App As femap.model
    Set App = feFemap()

	Dim pp As pdfPostExporter
	Set pp = New pdfPostExporter
	Set pp.App = App
	pp.init

	'Group 5 - shell elements only
	pp.fullModelID = 5
	'Working directory - target for the pdfPost input files
	pp.wD = "C:\Example1"
	'Project name for the file names
	pp.pN = "ship_e1"

	pp.AddGroup(10)
	pp.AddGroup(11)
	pp.AddGroup(12)

	pp.SaveElements
	pp.SaveNodes
	pp.SaveGroups
	pp.SaveVector(pp.pN + ".v1", 10, 3, 300006)
	pp.SaveDisp(pp.pN + ".def", 5, 3)
End Sub

'SUMMARY
'Method shows hot to export data based on Excel configuration file
Sub Example2
	Dim App As femap.model
    Set App = feFemap()

	Dim pp As pdfPostExporter
	Set pp = New pdfPostExporter
	Set pp.App = App

	'This requires to add Excel library in References
	Set pp.oExcel =  New Excel.Application
	pp.init

	pp.ExcelData("C:\Example2\example2.xlsx")
End Sub

'SUMMARY
'Methods shows how to export multiple PDF's based on excel configuration files
Sub Example3
	Dim App As femap.model
    Set App = feFemap()

	Dim pp As pdfPostExporter
	Set pp = New pdfPostExporter
	Set pp.App = App

	'This requires to add Excel library in References
	Set pp.oExcel =  New Excel.Application
	pp.init

	xmlBatchFile = "C:\Example3\example3_batch.xml"

	pp.ExcelBatch("C:\Example3\example3_batch.xlsx", xmlBatchFile)

	strProgramName = "C:\Program Files\BPSolutions\pdfPost x64\pdfPost.UI.exe"
    strArgument = " batchPath=" + xmlBatchFile + " batchClose=False"

    Call Shell(strProgramName & strArgument, vbNormalFocus)
End Sub

Public Class pdfPostExporter
	Public App As femap.model
	Public fullModelID As Variant
	Public wD As String
	Public pN As String
	Private Groups() As Integer
	Public oExcel As Object
	Public oXMLFile As Object
	Public XMLFileName As String

	'SUMMARY
	'Initialization method for pdfPostExporter class
	Public Sub init
		ReDim Groups(1 To 1)
		r = App.feAppMessage(FCM_NORMAL, "pdfPostExporter class 1.01b (02.05.2017).")
	End Sub

	'SUMMARY
	'Saves elements grouped in fullModelID group
	Sub SaveElements
		r = App.feAppMessage(FCM_NORMAL, "Wriiting elements..." )
		Dim El As femap.Elem
		Set El = App.feElem
		Dim elSet As femap.Set
		Set elSet = App.feSet

		Dim numElem As Long
		Dim entID ,propID ,elemType ,topology ,Lyr ,color ,formulation ,orient ,offset ,release ,orientSET ,orientID ,nodes ,connectTYPE ,connectSEG As Variant

		Dim tmpLine As String

		rc = elSet.AddGroup(FT_ELEM, fullModelID)
		rc = El.GetAllArray(elSet.ID, numElem, entID, propID, _
		elemType, topology, Lyr, color, formulation,orient,offset, _
		release, orientSET, orientID, nodes, connectTYPE, connectSEG )

		fName = wD + "\" + pN + ".elem"
		Open fName For Output As #1

		For i = 0 To numElem-1
			tmpLine = CStr(entID(i))
			tmpLine = tmpLine + "," + CStr(topology(i))
			For u = 0 To 20-1
	   			If nodes(i*20 + u) <> 0 Then
	     			tmpLine = tmpLine + ", "+ Str$(nodes(i*20 + u))
	   			End If
			Next u
			Print #1, tmpLine
		Next i
		Close #1
		r = App.feAppMessage(FCM_NORMAL, "Elements written (" + CStr(i) + ")." )
	End Sub

	'SUMMARY
	'Saves nodes on elements in fullModelID group
	Sub SaveNodes
	r = App.feAppMessage(FCM_NORMAL, "Wriiting nodes..." )
		Dim nSet As femap.Set
		Dim eSet As femap.Set
		Dim No As femap.Node

		Set No = App.feNode
		Set nSet = App.feSet
		Set eSet = App.feSet

		Dim entID, xyz, Lyr, color, ndType, defCSys, outCSys, permBC As Variant

		Dim numNode As Long
		Dim tmpLine As String

		fName = wD + "\" + pN + ".node"
		rc = eSet.AddGroup(FT_ELEM, fullModelID)

		rc = nSet.AddSetRule(eSet.ID, FGD_NODE_ONELEM)

		rc = No.GetAllArray(nSet.ID, numNode, entID, xyz, Lyr, color, ndType, defCSys, outCSys, permBC)
		Open fName For Output As #1
		For i = 0 To numNode-1
			tmpLine = CStr(entID(i))
			For u = 0 To 2
				tmpLine = tmpLine + "," + Replace(Format(xyz(i*3+u),"0.0000"),",",".")
			Next u
			Print #1, tmpLine
		Next i
		Close #1
		r = App.feAppMessage(FCM_NORMAL, "Nodes written (" + CStr(i) + ")." )
	End Sub

	'SUMMARY
	'Saves groups from Groups array - check method AddGroup
	Sub SaveGroups
		r = App.feAppMessage(FCM_NORMAL, "Wriiting groups..." )
		Dim oSet As femap.Set
		Set oSet = App.feSet

		fName = wD + "\" + pN + ".cm"
		Open fName For Output As #1

		For i =2 To UBound(Groups)
			r = App.feAppMessage(FCM_NORMAL, "Group " + CStr(Groups(i)))
			Print #1, "Group" + CStr(Groups(i))+ ",ELEMENTS"
			oSet.Clear
			oSet.AddGroup(FT_ELEM, Groups(i))
			While oSet.Next
				Print #1, CStr(oSet.CurrentID)
			Wend
		Next i
		Close #1
		r = App.feAppMessage(FCM_NORMAL, "Groups written (" + CStr(UBound(Groups)-1) + ")." )
	End Sub

	'SUMMARY
	'Adds groups to an array.
	Sub AddGroup(ID As Integer)
		Dim s As femap.Set
		Set s = App.feSet
		rc = s.AddGroup(FT_ELEM, ID)

		If ID = -1 Then
			Exit Sub
		End If
		If s.Count = 0 Then
			r = App.feAppMessage(FCM_WARNING, "Warning: Group empty or not found.")
			Exit Sub
		End If

		If UBound(Groups) = 1 Then
			Groups(1) = ID
		End If
		ReDim Preserve Groups(1 To UBound(Groups)+1)
		Groups(UBound(Groups)) = ID
	End Sub

	'SUMMARY
	'Saves result vetor for given set and group
	Sub SaveVector(fName As String, groupID As Long, outSetID As Long, vectorID As Long)
		r = App.feAppMessage(FCM_NORMAL, "Writing vector " + CStr(vectorID) + " from Set " + CStr(outSetID) + ".")
		Dim selID, i As Long

		Dim oSet As femap.Set
		Set oSet = App.feSet

		Dim v, dv As Variant

		Dim oOutput As femap.Output
		Set oOutput = App.feOutput

		Open wD + "\" + fName For Output As #1

		'Adding elements from specific group to a Set
		oSet.AddGroup(FT_ELEM, groupID)

		'Getting data from specified output set and vetor
		oOutput.GetFromSet(outSetID, vectorID)

		'Getting data from output for set elements
		oOutput.GetOutputListAtSet(oSet.ID, dv, v)

		While oSet.Next
			Print #1, CStr(oSet.CurrentID) + "," + Replace(CStr(Format(v(i), "0.0000")), ",",".")
			i = i +1
		Wend
		Close #1
		r = App.feAppMessage(FCM_NORMAL, "Vector written (" + CStr(i) + ").")
	End Sub

	Sub SaveDisp(fName As String, groupID As Long, outSetID As Long)
		r = App.feAppMessage(FCM_NORMAL, "Writing displacements from Set " + CStr(outSetID) + ".")
		Dim selID, i As Long

		Dim eSet, oSet As femap.Set
		Set oSet = App.feSet
		Set eSet = App.feSet

		Dim vx, vy, vz, dv As Variant

		Dim oOutput As femap.Output
		Set oOutput = App.feOutput

		Open wD + "\" + fName For Output As #1

		'Adding elements from specific group to a Set
		rc = eSet.AddGroup(FT_ELEM, groupID)
		rc = oSet.AddSetRule(eSet.ID, FGD_NODE_ONELEM)

		'Getting data from specified output set and vetor
		oOutput.GetFromSet(outSetID, 2)
		oOutput.GetOutputListAtSet(oSet.ID, dv, vx)
		oOutput.GetFromSet(outSetID, 3)
		oOutput.GetOutputListAtSet(oSet.ID, dv, vy)
		oOutput.GetFromSet(outSetID, 4)
		oOutput.GetOutputListAtSet(oSet.ID, dv, vz)

		While oSet.Next
			Print #1, CStr(oSet.CurrentID) + "," + Replace(CStr(Format(vx(i), "0.0000")), ",",".") + "," + Replace(CStr(Format(vy(i), "0.0000")), ",",".") + "," + Replace(CStr(Format(vz(i), "0.0000")), ",",".")
			i = i +1
		Wend
		Close #1
		r = App.feAppMessage(FCM_NORMAL, "Displacements written (" + CStr(i) + ").")
	End Sub

	'SUMMARY
	'Method creates XML batch file from XLSX input file
	'Source file - source XLSX file (full path)
	'Target file - target XML file (full path)
	Public Sub ExcelBatch(sourceFile As String, targetFile As String)
		Dim oWorkbook As Object
		Set oWorkbook = oExcel.Workbooks.Open(sourceFile, True)

		Dim oXMLBatch As Object

		Dim oBatch As Object
		Set oBatch = oWorkbook.Worksheets(1)

		Dim r0, r As Object
		Set r = oBatch.Range("A2","C2")
		Set r0 = oBatch.Range("A1","C1")

		Set oXMLBatch = CreateObject("Microsoft.XMLDOM")

   		oXMLBatch.appendChild oXMLBatch.createElement("pdfPost_ConfigurationBatch")
		Do While True
			If r.Item(1).text = "" Then
				Exit Do
			End If
			Set xmlFile = oXMLBatch.createElement("ConfigurationFile")
			For i = 1 To 3
				xmlFile.setAttribute r0.Item(i).text, r.Item(i).text
			Next i
			oXMLBatch.firstChild.appendChild xmlFile
			ReDim Groups(1 To 1)
			'ExcelData(r.Item(2).text + "\" + r.Item(1).text)
			ExcelData(r.Item(2).text + "\" + Replace(r.Item(1).text, ".xml", ".xlsx"))
			Set r = r.offset(RowOffSet:=1, ColumnOffset:=0)
		Loop
		oXMLBatch.Save(targetFile)
		oWorkbook.Close SaveChanges:= False
	End Sub

	'SUMMARY
	'Creates pdfPost input data files and XML configuration file based on Excel XLSX input file
	Public Sub ExcelData(file As String)
		Dim oWorkbook As Object
		Set oWorkbook = oExcel.Workbooks.Open(file, True)

		Dim oDocument, oPlots, oComponents As Object
		Set oDocument = oWorkbook.Worksheets(1)
		Set oPlots = oWorkbook.Worksheets(2)
		Set oComponents = oWorkbook.Worksheets(3)

		initConfigurationXML
		ExcelXMLDocument(oDocument)
		ExcelXMLPlots(oPlots)
		ExcelXMLComponents(oComponents)
		ElTypes
		endConfigurationXML

		SaveElements
		SaveNodes
		SaveGroups

		oWorkbook.Close SaveChanges:=False
	End Sub

	'SUMMARY
	'XML Document element in pdfPost XML Configuration file. Based on Excel XLSX input file.
	Public Sub ExcelXMLDocument(oSheet As Object)
		Dim r As Object
		Set r = oSheet.Range("B1","B3")
		wD = r.Item(1,1).text
		pN = r.Item(2,1).text
		fullModelID = r.Item(3,1).text
		r = App.feAppMessage(FCM_NORMAL, wD)

		Set docElement = oXMLFile.createElement("Document")

		docElement.setAttribute "ProjectName", pN
		docElement.setAttribute "ElementsFile", pN + ".elem"
		docElement.setAttribute "NodesFile", pN + ".node"
		docElement.setAttribute "ComponentsFile", pN + ".cm"
		docElement.setAttribute "OutputFile", pN + ".pdf"

		oXMLFile.firstChild.appendChild docElement
	End Sub

	'SUMMARY
	'XML Plot elements in pdfPost XML Configuration file. Based on Excel XLSX input file.
	Public Sub ExcelXMLPlots(oSheet As Object)
		Dim currentPlot As Integer
		Dim cText, ct As String
		currentPlot = 1
		Dim r, r0 As Object

		Set r = oSheet.Range("B1","B25")
		Set r0 = oSheet.Range("A1","A25")

		cText =r.Item(1).text
		Do While True
			cText = r.Item(1).text
			If cText = "" Then
				Exit Do
			End If
			Set xmlPlot = oXMLFile.createElement("Plot")
			SaveVector(r.Item(13).text, r.Item(3).text, r.Item(1).text, r.Item(2).text)
			If r.Item(17) <> "" Then
				SaveDisp(r.Item(17).text, fullModelID, r.Item(1).text)
			End If
			For i = 5 To r.Count
				xmlPlot.setAttribute r0.Item(i), r.Item(i)
			Next i
			oXMLFile.firstChild.appendChild xmlPlot
			currentPlot = currentPlot +1
			Set r = r.offset(RowOffSet:=0, ColumnOffset:=1)
		Loop
	End Sub

	'SUMMARY
	'XML Component elements in pdfPost XML Configuration file. Based on Excel XLSX input file.
	Sub ExcelXMLComponents(oSheet As Object)
		Dim currentCmp As Integer
		Dim r0, r As Object
		'Dim r As Range

		currentCmp = 1

		Set r0 = oSheet.Range("A1:G1")
		Set r = oSheet.Range("A2:G2")
		Do While True
			If r.Item(1).text = "" Then
				Exit Do
			End If
			Set xmlCmp = oXMLFile.createElement("Component")
			AddGroup(r.Item(1).value)
			For j = 2 To 7
				xmlCmp.setAttribute r0.Item(j), r.Item(j)
			Next j
			oXMLFile.firstChild.appendChild xmlCmp
			Set r = r.offset(RowOffset:=1, ColumnOffset:=0)
		Loop
	End Sub

	'SUMMARY
	'XML Element elements in pdfPost XML Configuration file. Only currently supported types introduced.
	Sub ElTypes
		Dim eID(1 To 4) As String
		Dim eName(1 To 4) As String

		eID(1) = "0"
		eName(1) ="pdfPost_LINE2"
		eID(2) = "1"
		eName(2) ="pdfPost_LINE2"
		eID(3) = "2"
		eName(3) ="pdfPost_PLANE3"
		eID(4) = "4"
		eName(4) ="pdfPost_PLANE4"

		For i = 1 To UBound(eID)
			Set xmlET = oXMLFile.CreateElement("Element")
			xmlET.setAttribute "ElementTypeNo", eID(i)
			xmlET.setAttribute "ElementTypeName", eName(i)
			oXMLFile.firstChild.appendChild xmlET
		Next i
	End Sub

	'SUMMARY
	'Initialize pdfPost XML configuration file
	Sub initConfigurationXML
		Set oXMLFile = CreateObject("Microsoft.XMLDOM")

    	' Creates root element
   		oXMLFile.appendChild oXMLFile.createElement("pdfPost_Configuration")
	End Sub

	'SUMMARY
	'End pdfPost XML configuration file
	Sub endConfigurationXML
		oXMLFile.Save(wD + "\" + pN + ".xml")
	End Sub

End Class
